git-rebase.sh 7.8 KB
Newer Older
1 2 3 4 5
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano.
#

6
USAGE='[--onto <newbase>] <upstream> [<branch>]'
7 8 9 10 11
LONG_USAGE='git-rebase replaces <branch> with a new branch of the
same name.  When the --onto option is provided the new branch starts
out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
It then attempts to create a new commit for each commit from the original
<branch> that does not exist in the <upstream> branch.
12

13 14
It is possible that a merge failure will prevent this process from being
completely automatic.  You will have to resolve any such merge failure
15 16 17 18
and run git rebase --continue.  Another option is to bypass the commit
that caused the merge failure with git rebase --skip.  To restore the
original <branch> and remove the .dotest working files, use the command
git rebase --abort instead.
19

20 21 22
Note that if <branch> is not specified on the command line, the
currently checked out branch is used.  You must be in the top
directory of your project to start (or continue) a rebase.
23

24
Example:       git-rebase master~1 topic
25

26 27 28
        A---B---C topic                   A'\''--B'\''--C'\'' topic
       /                   -->           /
  D---E---F---G master          D---E---F---G master
29
'
30
. git-sh-setup
31

32 33 34 35 36
RESOLVEMSG="
When you have resolved this problem run \"git rebase --continue\".
If you would prefer to skip this patch, instead run \"git rebase --skip\".
To restore the original branch and stop rebasing run \"git rebase --abort\".
"
37
unset newbase
J
Junio C Hamano 已提交
38
strategy=recursive
39 40 41 42 43 44 45 46 47 48 49 50 51
do_merge=
dotest=$GIT_DIR/.dotest-merge
prec=4

continue_merge () {
	test -n "$prev_head" || die "prev_head must be defined"
	test -d "$dotest" || die "$dotest directory does not exist"

	unmerged=$(git-ls-files -u)
	if test -n "$unmerged"
	then
		echo "You still have unmerged paths in your index"
		echo "did you forget update-index?"
52
		die "$RESOLVEMSG"
53 54 55 56
	fi

	if test -n "`git-diff-index HEAD`"
	then
57 58 59 60 61 62
		if ! git-commit -C "`cat $dotest/current`"
		then
			echo "Commit failed, please do not call \"git commit\""
			echo "directly, but instead do one of the following: "
			die "$RESOLVEMSG"
		fi
63
		printf "Committed: %0${prec}d" $msgnum
64
	else
65
		printf "Already applied: %0${prec}d" $msgnum
66
	fi
67 68
	echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
				sed 's/^[a-f0-9]\+ //'`
69 70 71 72 73 74 75

	prev_head=`git-rev-parse HEAD^0`
	# save the resulting commit so we can read-tree on it later
	echo "$prev_head" > "$dotest/prev_head"

	# onto the next patch:
	msgnum=$(($msgnum + 1))
76
	echo "$msgnum" >"$dotest/msgnum"
77 78 79
}

call_merge () {
80
	cmt="$(cat $dotest/cmt.$1)"
81 82 83 84 85
	echo "$cmt" > "$dotest/current"
	git-merge-$strategy "$cmt^" -- HEAD "$cmt"
	rv=$?
	case "$rv" in
	0)
86
		return
87 88 89
		;;
	1)
		test -d "$GIT_DIR/rr-cache" && git-rerere
90
		die "$RESOLVEMSG"
91 92 93
		;;
	2)
		echo "Strategy: $rv $strategy failed, try another" 1>&2
94
		die "$RESOLVEMSG"
95 96 97 98 99 100 101 102 103 104 105 106 107
		;;
	*)
		die "Unknown exit code ($rv) from command:" \
			"git-merge-$strategy $cmt^ -- HEAD $cmt"
		;;
	esac
}

finish_rb_merge () {
	rm -r "$dotest"
	echo "All done."
}

108 109 110
while case "$#" in 0) break ;; esac
do
	case "$1" in
111 112 113 114 115 116 117 118
	--continue)
		diff=$(git-diff-files)
		case "$diff" in
		?*)	echo "You must edit all merge conflicts and then"
			echo "mark them as resolved using git update-index"
			exit 1
			;;
		esac
119 120 121 122 123 124 125 126 127 128 129 130 131 132 133
		if test -d "$dotest"
		then
			prev_head="`cat $dotest/prev_head`"
			end="`cat $dotest/end`"
			msgnum="`cat $dotest/msgnum`"
			onto="`cat $dotest/onto`"
			continue_merge
			while test "$msgnum" -le "$end"
			do
				call_merge "$msgnum"
				continue_merge
			done
			finish_rb_merge
			exit
		fi
134 135
		git am --resolved --3way --resolvemsg="$RESOLVEMSG" \
			--reflog-action=rebase
136 137 138
		exit
		;;
	--skip)
139 140
		if test -d "$dotest"
		then
141 142 143 144 145 146 147 148 149 150 151 152
			prev_head="`cat $dotest/prev_head`"
			end="`cat $dotest/end`"
			msgnum="`cat $dotest/msgnum`"
			msgnum=$(($msgnum + 1))
			onto="`cat $dotest/onto`"
			while test "$msgnum" -le "$end"
			do
				call_merge "$msgnum"
				continue_merge
			done
			finish_rb_merge
			exit
153
		fi
154 155
		git am -3 --skip --resolvemsg="$RESOLVEMSG" \
			--reflog-action=rebase
156 157 158
		exit
		;;
	--abort)
159 160 161 162 163 164 165 166 167
		if test -d "$dotest"
		then
			rm -r "$dotest"
		elif test -d .dotest
		then
			rm -r .dotest
		else
			die "No rebase in progress?"
		fi
168 169 170
		git reset --hard ORIG_HEAD
		exit
		;;
171 172 173 174 175
	--onto)
		test 2 -le "$#" || usage
		newbase="$2"
		shift
		;;
176 177 178 179 180 181 182 183
	-M|-m|--m|--me|--mer|--merg|--merge)
		do_merge=t
		;;
	-s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
		--strateg=*|--strategy=*|\
	-s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
		case "$#,$1" in
		*,*=*)
D
Dennis Stosberg 已提交
184
			strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
185 186 187 188 189 190 191 192
		1,*)
			usage ;;
		*)
			strategy="$2"
			shift ;;
		esac
		do_merge=t
		;;
193 194 195 196 197 198 199 200 201
	-*)
		usage
		;;
	*)
		break
		;;
	esac
	shift
done
202

203
# Make sure we do not have .dotest
204
if test -z "$do_merge"
205
then
206 207 208 209 210
	if mkdir .dotest
	then
		rmdir .dotest
	else
		echo >&2 '
211 212 213 214
It seems that I cannot create a .dotest directory, and I wonder if you
are in the middle of patch application or another rebase.  If that is not
the case, please rm -fr .dotest and run me again.  I am stopping in case
you still have something valuable there.'
215 216 217 218 219 220 221 222
		exit 1
	fi
else
	if test -d "$dotest"
	then
		die "previous dotest directory $dotest still exists." \
			'try git-rebase < --continue | --abort >'
	fi
223 224
fi

225
# The tree must be really really clean.
J
Junio C Hamano 已提交
226
git-update-index --refresh || exit
227
diff=$(git-diff-index --cached --name-status -r HEAD)
L
Lukas Sandström 已提交
228
case "$diff" in
229 230 231 232
?*)	echo "$diff"
	exit 1
	;;
esac
J
Junio C Hamano 已提交
233

234 235 236
# The upstream head must be given.  Make sure it is valid.
upstream_name="$1"
upstream=`git rev-parse --verify "${upstream_name}^0"` ||
J
Jason Riedy 已提交
237
    die "invalid upstream $upstream_name"
L
Lukas Sandström 已提交
238

239 240 241 242 243 244 245 246 247
# If a hook exists, give it a chance to interrupt
if test -x "$GIT_DIR/hooks/pre-rebase"
then
	"$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
		echo >&2 "The pre-rebase hook refused to rebase."
		exit 1
	}
fi

248
# If the branch to rebase is given, first switch to it.
249
case "$#" in
250
2)
251
	branch_name="$2"
252
	git-checkout "$2" || usage
253 254 255
	;;
*)
	branch_name=`git symbolic-ref HEAD` || die "No current branch"
256
	branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
257
	;;
258
esac
259
branch=$(git-rev-parse --verify "${branch_name}^0") || exit
260

261 262 263
# Make sure the branch to rebase onto is valid.
onto_name=${newbase-"$upstream_name"}
onto=$(git-rev-parse --verify "${onto_name}^0") || exit
L
Lukas Sandström 已提交
264

265 266 267 268
# Now we are rebasing commits $upstream..$branch on top of $onto

# Check if we are already based on $onto, but this should be
# done only when upstream and onto are the same.
269 270
mb=$(git-merge-base "$onto" "$branch")
if test "$upstream" = "$onto" && test "$mb" = "$onto"
271
then
272 273
	echo >&2 "Current branch $branch_name is up to date."
	exit 0
274 275
fi

276 277
# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
git-reset --hard "$onto"
L
Lukas Sandström 已提交
278

279
# If the $onto is a proper descendant of the tip of the branch, then
L
Lukas Sandström 已提交
280
# we just fast forwarded.
281
if test "$mb" = "$branch"
L
Lukas Sandström 已提交
282
then
283
	echo >&2 "Fast-forwarded $branch_name to $onto_name."
L
Lukas Sandström 已提交
284 285 286
	exit 0
fi

287 288 289
if test -z "$do_merge"
then
	git-format-patch -k --stdout --full-index "$upstream"..ORIG_HEAD |
290 291
	git am --binary -3 -k --resolvemsg="$RESOLVEMSG" \
		--reflog-action=rebase
292 293 294
	exit $?
fi

J
Junio C Hamano 已提交
295
if test "@@NO_PYTHON@@" && test "$strategy" = "recursive-old"
296
then
J
Junio C Hamano 已提交
297
	die 'The recursive-old merge strategy is written in Python,
298
which this installation of git was not configured with.  Please consider
J
Junio C Hamano 已提交
299
a different merge strategy (e.g. recursive, resolve, or stupid)
300 301 302 303
or install Python and git with Python support.'

fi

304 305 306 307 308 309 310 311 312 313
# start doing a rebase with git-merge
# this is rename-aware if the recursive (default) strategy is used

mkdir -p "$dotest"
echo "$onto" > "$dotest/onto"
prev_head=`git-rev-parse HEAD^0`
echo "$prev_head" > "$dotest/prev_head"

msgnum=0
for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
M
Michal Rokos 已提交
314
			| @@PERL@@ -e 'print reverse <>'`
315 316
do
	msgnum=$(($msgnum + 1))
317
	echo "$cmt" > "$dotest/cmt.$msgnum"
318 319
done

320 321
echo 1 >"$dotest/msgnum"
echo $msgnum >"$dotest/end"
322 323 324 325 326 327 328 329 330

end=$msgnum
msgnum=1

while test "$msgnum" -le "$end"
do
	call_merge "$msgnum"
	continue_merge
done
331

332
finish_rb_merge